﻿//
// Copyright(c) 2013,株式会社トラスト・ソフトウェア・システム
//
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Vwr
{
    public partial class Form1 : Form
    {
        private VIEWEROCXLib.TPDFCursorMode ccm;

        public Form1()
        {
            InitializeComponent();
#if false
            axPDFViewer1.Open("input.pdf");
#else
            OpenFileDialog dlg = new OpenFileDialog();
            dlg.Filter = "PDFファイル(*.pdf)|*.pdf|すべて(*.*)|*.*";
            dlg.Title = "開くファイルを指定";
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                axPDFViewer1.Open(dlg.FileName);
                cmbFitMode.SelectedIndex = 2;
                cmbZoom.Text = axPDFViewer1.Zoom.ToString("f1") + "%";
                ccm = VIEWEROCXLib.TPDFCursorMode.eCursorModeMove;
            }
            else
            {
                cbOutline.Enabled = cbOutline.Checked = false;
                cbLayout.Enabled = cbLayout.Checked = false;
                btnTopPage.Enabled = btnPrevPage.Enabled = btnNextPage.Enabled = btnLastPage.Enabled = false;
                cmbFitMode.Enabled = cmbZoom.Enabled = false;
            }
#endif
        }

        //終了
        private void closeBtn_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        //「しおり」表示変更
        private void cbOutline_CheckedChanged(object sender, EventArgs e)
        {
            if (cbOutline.Checked)
            {
                axPDFViewer1.ViewerOptions = axPDFViewer1.ViewerOptions | (int)VIEWEROCXLib.TPDFViewerOption.eViewerOptionOutlines;
            }
            else
            {
                axPDFViewer1.ViewerOptions = axPDFViewer1.ViewerOptions & ~(int)VIEWEROCXLib.TPDFViewerOption.eViewerOptionOutlines;
            }
        }

        //レイアウトモード変更
        private void cbLayout_CheckedChanged(object sender, EventArgs e)
        {
            if (cbLayout.Checked)
            {
                axPDFViewer1.LayoutMode = VIEWEROCXLib.TPDFLayoutMode.eLayoutDocument;
            }
            else
            {
                axPDFViewer1.LayoutMode = VIEWEROCXLib.TPDFLayoutMode.eLayoutPage;
            }
        }

        //最初のページ
        private void btnTopPage_Click(object sender, EventArgs e)
        {
            axPDFViewer1.Page = 1;
        }

        //前のページ
        private void btnPrevPage_Click(object sender, EventArgs e)
        {
            axPDFViewer1.Page = axPDFViewer1.Page - 1;
        }

        //次のページ
        private void btnNextPage_Click(object sender, EventArgs e)
        {
            axPDFViewer1.Page = axPDFViewer1.Page + 1;
        }

        //最後のページ
        private void btnLastPage_Click(object sender, EventArgs e)
        {
            axPDFViewer1.Page = axPDFViewer1.PageCount;
        }

        //ページが移動した
        private void axPDFViewer1_OnPage(object sender, AxVIEWEROCXLib._IPDFViewerEvents_OnPageEvent e)
        {
            lblPageInfo.Text = string.Format("{0}/{1}", e.iPage, axPDFViewer1.PageCount);
            if (axPDFViewer1.PageCount == 1)
            {
                btnTopPage.Enabled = btnPrevPage.Enabled = false;
                btnNextPage.Enabled = btnLastPage.Enabled = false;
            }
            else if (axPDFViewer1.Page == 1)
            {
                btnTopPage.Enabled = btnPrevPage.Enabled = false;
                btnNextPage.Enabled = btnLastPage.Enabled = true;
            }
            else if (axPDFViewer1.Page == axPDFViewer1.PageCount)
            {
                btnTopPage.Enabled = btnPrevPage.Enabled = true;
                btnNextPage.Enabled = btnLastPage.Enabled = false;
            }
            else
            {
                btnTopPage.Enabled = btnPrevPage.Enabled =
                btnNextPage.Enabled = btnLastPage.Enabled = true;
            }
        }

        //ページ回転
        private void btnRotate_Click(object sender, EventArgs e)
        {
            int d = (int)axPDFViewer1.Rotate + 90;
            if (d == 360) d = 0;
            axPDFViewer1.Rotate = (short)d;
        }

        //フィットモード変更
        private void cmbFitMode_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (cmbFitMode.SelectedIndex)
            {
                case 0:
                    axPDFViewer1.FitMode = VIEWEROCXLib.TPDFFitMode.eFitModeActualSize;
                    break;
                case 1:
                    axPDFViewer1.FitMode = VIEWEROCXLib.TPDFFitMode.eFitModePage;
                    break;
                case 2:
                    axPDFViewer1.FitMode = VIEWEROCXLib.TPDFFitMode.eFitModeWidth;
                    break;
                default:
                    cmbZoom.Enabled = true;
                    return;
            }
            cmbZoom.Text = axPDFViewer1.Zoom.ToString("f1") + "%";
            cmbZoom.Enabled = false;
        }

        //倍率変更
        private void cmbZoom_TextChanged(object sender, EventArgs e)
        {
            System.Text.RegularExpressions.Regex reg = new System.Text.RegularExpressions.Regex("[0-9]+", System.Text.RegularExpressions.RegexOptions.Singleline);
            System.Text.RegularExpressions.Match m = reg.Match(cmbZoom.Text);
            if (m.Success) axPDFViewer1.Zoom = int.Parse(m.ToString());
            else axPDFViewer1.Zoom = 100;
        }
        private void cmbZoom_Leave(object sender, EventArgs e)
        {
            cmbZoom.Text = axPDFViewer1.Zoom.ToString("f1") + "%";
        }

        //印刷
        private void btnPrnt_Click(object sender, EventArgs e)
        {
            axPDFViewer1.PrintDocumentDlg();
        }

        //Webリンクを通常のブラウザで開く
        private void axPDFViewer1_OnURI(object sender, AxVIEWEROCXLib._IPDFViewerEvents_OnURIEvent e)
        {
            System.Diagnostics.Process.Start(e.bstrURI);
        }

        //領域を指定してズームインする
        private void btnZoomRect_Click(object sender, EventArgs e)
        {
            btnZoomRect.Enabled = false;
            ccm = axPDFViewer1.CursorMode;
            axPDFViewer1.CursorMode = VIEWEROCXLib.TPDFCursorMode.eCursorModeZoom;
        }
        //領域を指定してズームインした
        private void axPDFViewer1_OnZoomRect(object sender, AxVIEWEROCXLib._IPDFViewerEvents_OnZoomRectEvent e)
        {
            axPDFViewer1.CursorMode = ccm;
            btnZoomRect.Enabled = true;
            cmbZoom.Text = axPDFViewer1.Zoom.ToString("f1") + "%";
        }

        private void btnPrnt2_Click(object sender, EventArgs e)
        {
            Form2 dlg = new Form2(axPDFViewer1);
            dlg.ShowDialog();
            dlg.Dispose();
        }
    }
}
